public class HTTPValladolid {
  public static void main(String[] args) throws Exception {
    Post("123",
         "28595JR",
         "C",
         "Simple Program",
         "100.c",

         "#include <stdio.h>\n" +
         "int main() {\n" +
         "  printf(\"Hello, world!\n\");\n" +
         "  return 0;\n" +
         "}\n");
  }

  public static boolean Post(String problemNumber,
                             String uvaId,
                             String language,
                             String comment,
                             String fileName,
                             String fileContent) {
    java.net.URLConnection connection;
    try {
      connection =
        (new java.net.URL("http://acm.uva.es/p/submit.php")).openConnection();
    } catch (java.io.IOException e) { return false; }
    
    connection.setDoOutput(true);
    connection.setRequestProperty("Host", "acm.uva.es");
    connection.setRequestProperty("Connection", "close");
    connection.setRequestProperty("Content-Type",
                                  "multipart/form-data; boundary=19810924");
    String postContent = makePostContent(problemNumber,
                                         uvaId,
                                         language,
                                         comment,
                                         fileName,
                                         fileContent);
    connection.setRequestProperty("Content-length", "" + postContent.length());

    java.io.PrintWriter printWriter;
    try {
      printWriter = new java.io.PrintWriter(connection.getOutputStream());
    } catch (java.io.IOException e) { return false; }
    printWriter.print(postContent);
    printWriter.close();

    try {
      connection.getInputStream().close();
    } catch (java.io.IOException e) { return true; }
    return true;
  }

  private static String makePostContent(String problemNumber,
                                 String uvaId,
                                 String language,
                                 String comment,
                                 String fileName,
                                 String fileContent) {
    String postContent =
      "--19810924\n" +
      "Content-Disposition: form-data; name=\"paso\"\r\n" +
      "\r\n" +
      "paso\r\n" +
      
      "--19810924\n" +
      "Content-Disposition: form-data; name=\"problem\"\r\n" +
      "\r\n" +
      problemNumber + "\r\n" +

      "--19810924\n" +
      "Content-Disposition: form-data; name=\"userid\"\r\n" +
      "\r\n" +
      uvaId + "\r\n" +

      "--19810924\n" +
      "Content-Disposition: form-data; name=\"language\"\r\n" +
      "\r\n" +
      language + "\r\n" +

      "--19810924\n" +
      "Content-Disposition: form-data; name=\"comment\"\r\n" +
      "\r\n" +
      comment + "\r\n" +

      "--19810924\n" +
      "Content-Disposition: form-data; name=\"codefile\"; filename=\"" + fileName + "\"\r\n" +
      "Content-Type: text-plain\r\n" +
      "\r\n" +
      fileContent +

      "--19810924\n" +
      "Content-Disposition: form-data; name=\"submit\"\r\n" +
      "\r\n" +
      "                    Submit problem                    \r\n" +

      "--19810924--";

    return postContent;
  }
}
