import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;

public class UVAJudgeFrame extends JFrame {
  //  private UVAJudge client;
  private Container containerFrame;

  private JPanel panelExit;
  private JButton buttonExit;
  private ExitActionListener actionListenerExit;

  private JPanel panelRun;
  private JTable tableRun;
  private JTableHeader tableHeaderRun;
  private UVARunTableModel tableModelRun;

  private JPanel panelRefresh;
  private JButton buttonRefresh;
  private RefreshActionListener actionListenerRefresh;


  public UVAJudgeFrame(UVAJudge client,
                       UVARunTableModel tableModelRun,
                       String title, java.awt.GraphicsConfiguration gc) {
    super(title, gc);
    this.tableModelRun = tableModelRun;
    setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);

    actionListenerExit = new ExitActionListener(client);
    buttonExit = new JButton("Exit");
    buttonExit.addActionListener(actionListenerExit);
    panelExit = new JPanel();
    panelExit.setLayout(new BorderLayout());
    panelExit.add(buttonExit, BorderLayout.EAST);

    this.tableModelRun = tableModelRun;
    tableHeaderRun = new JTableHeader();
    tableRun = new JTable(tableModelRun);
    tableRun.setTableHeader(tableHeaderRun);
    // $B$3$l$O9T$b;XDj$G$-$J$/$J$k(B
    //    tableRun.setCellSelectionEnabled(false);
    panelRun = new JPanel();
    panelRun.setLayout(new BorderLayout());
    panelRun.add(tableRun, BorderLayout.CENTER);

    actionListenerRefresh = new RefreshActionListener(tableModelRun);
    buttonRefresh = new JButton("Refresh");
    buttonRefresh.addActionListener(actionListenerRefresh);
    panelRefresh = new JPanel();
    panelRefresh.setLayout(new BorderLayout());
    panelRefresh.add(buttonRefresh, BorderLayout.SOUTH);

    containerFrame = this.getContentPane();
    containerFrame.setLayout(new BorderLayout());
    containerFrame.add(panelExit, BorderLayout.NORTH);
    containerFrame.add(panelRun, BorderLayout.CENTER);
    containerFrame.add(panelRefresh, BorderLayout.SOUTH);
  }

  ///////////////////////////////////////////////////////////////////////////
  //     1         2         3         4         5         6         7      7
  // 678901234567890123456789012345678901234567890123456789012345678901234567
  ///////////////////////////////////////////////////////////////////////////
  public UVAJudgeFrame(UVAJudge client, UVARunTableModel tableModelRun) {
    this(client, tableModelRun, null, null);
  }
  public UVAJudgeFrame(UVAJudge client, UVARunTableModel tableModelRun,
                       String title) {
    this(client, tableModelRun, title, null);
  }
  public UVAJudgeFrame(UVAJudge client, UVARunTableModel tableModelRun,
                       java.awt.GraphicsConfiguration gc) {
    this(client, tableModelRun, null, gc);
  }

  /* Sub-classes */
  class ExitActionListener implements java.awt.event.ActionListener {
    private UVAJudge client;
    public ExitActionListener(UVAJudge client) {
      this.client = client;
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      client.logoffPC2();
      System.exit(0);
    }
  }

  class RefreshActionListener implements java.awt.event.ActionListener {
    private UVARunTableModel runTableModel;
    public RefreshActionListener(UVARunTableModel runTableModel) {
      this.runTableModel = runTableModel;
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      /*
      runTableModel.addRow();
      */
      runTableModel.fireTableStructureChanged();
    }
  }
}
