import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class UVAJudgeLogin extends JFrame {
  private Container containerFrame;

  private JButton buttonLogin;
  private JButton buttonExit;

  private JTextField textPC2User;
  private JPasswordField textPC2Password;
  private JTextField textMailServer;
  private JTextField textMailUser;
  private JPasswordField textMailPassword;

  private static boolean isLoggedIn;

  private UVAJudgeLogin() {
    super("PC^2 UVA-Judge Login");
    buttonExit = new JButton("Exit");
    buttonExit.addActionListener(new ExitActionListener());
    buttonLogin = new JButton("Login");
    buttonLogin.addActionListener(new LoginActionListener());
    textPC2User = new JTextField();
    textPC2Password = new JPasswordField();
    textMailServer = new JTextField();
    textMailUser = new JTextField();
    textMailPassword = new JPasswordField();

    containerFrame = this.getContentPane();
    containerFrame.setLayout(new GridLayout(7, 2));
    containerFrame.add(textPC2User);
    containerFrame.add(textPC2Password);
    containerFrame.add(textMailServer);
    containerFrame.add(textMailUser);
    containerFrame.add(textMailPassword);
    containerFrame.add(buttonLogin);
    containerFrame.add(buttonExit);

    pack();
  }

  public static LoginInfo loginDialog() {
    UVAJudgeLogin frame = new UVAJudgeLogin();
    frame.show();
    isLoggedIn = false;
    while (!isLoggedIn) {
      try { java.lang.Thread.sleep(1000); }
      catch (InterruptedException e) { continue; }
    }

    LoginInfo info = new LoginInfo(frame.textPC2User.getText(),
                                   frame.textPC2Password.getText(),
                                   frame.textMailServer.getText(),
                                   frame.textMailUser.getText(),
                                   frame.textMailPassword.getText());
    frame.setVisible(false);
    return info;
  }

  public static class LoginInfo {
    public String pc2User;
    public String pc2Password;
    public String mailServer;
    public String mailUser;
    public String mailPassword;
    public LoginInfo(String pc2User, String pc2Password,
                     String mailServer, String mailUser, String mailPassword) {
      this.pc2User = pc2User;
      this.pc2Password = pc2Password;
      this.mailServer = mailServer;
      this.mailUser = mailUser;
      this.mailPassword = mailPassword;
    }
  }

  class ExitActionListener implements java.awt.event.ActionListener {
    public ExitActionListener() {}
    public void actionPerformed(ActionEvent event) {
      System.exit(0);
    }
  }

  class LoginActionListener implements java.awt.event.ActionListener {
    public LoginActionListener() {}
    public void actionPerformed(ActionEvent event) {
      isLoggedIn = true;
    }
  }
}
