public class UVARunInfoAndFiles {
  public static final int STATUS_SUBMITTED        = 0;
  public static final int STATUS_PROGRAM_RECEIVED = 1;
  public static final int STATUS_JUDGED           = 2;
  private int status;
  public int getStatus() { return status; }

  private long userId;
  public long getUserId() { return userId; }
  private long userSiteId;
  public long getUserSiteId() { return userSiteId; }
  private long runId;
  public long getRunId() { return runId; }
  private String sourceId;
  public String getSourceId() { return sourceId; }
  private String submitId;
  public String getSubmitId() { return submitId; }
  private long result;
  public long getResult() { return result; }

  public UVARunInfoAndFiles(long userId, long userSiteId, long runId,
                            String sourceId) {
    this.userId     = userId;
    this.userSiteId = userSiteId;
    this.runId      = runId;
    this.sourceId   = sourceId;
    this.status = STATUS_SUBMITTED;
  }

  public UVARunInfoAndFiles(long userId, long userSiteId, long runId,
                            String sourceId, String submitId) {
    this(userId, userSiteId, runId, sourceId);
    this.submitId   = submitId;
    this.status = STATUS_PROGRAM_RECEIVED;
  }

  public UVARunInfoAndFiles(long userId, long userSiteId, long runId,
                            String sourceId, String submitId, int result) {
    this(userId, userSiteId, runId, sourceId, submitId);
    this.result     = result;
    this.status = STATUS_JUDGED;
  }
}
