import java.util.*;

class UVARunTableModel extends javax.swing.table.AbstractTableModel {
  private ArrayList listRun = null;
  
  public UVARunTableModel() {
    super();
    listRun = new ArrayList();
  }
  public boolean isCellEditable(int rowIndex, int colmunIndex) {
    return false;
  }
  public int getRowCount() {
    if (listRun == null) { return 0; }
    return listRun.size();
  }
  public int getColumnCount() {
    return 6;
  }
  public Object getValueAt(int rowIndex, int colmunIndex) {
    UVARunInfoAndFiles uvaRun;
    uvaRun = (UVARunInfoAndFiles)(listRun.get(rowIndex));

    if (colmunIndex == 0) { return "" + uvaRun.getRunId(); }
    if (colmunIndex == 1) { return "" + uvaRun.getUserSiteId(); }
    if (colmunIndex == 2) { return "" + uvaRun.getUserId(); }
    if (colmunIndex == 3) { return uvaRun.getSourceId(); }
    if (colmunIndex == 4) {
      if (uvaRun.getStatus() == UVARunInfoAndFiles.STATUS_PROGRAM_RECEIVED) {
        return uvaRun.getSubmitId();
      }
      else {
        return "";
      }
    }
    if (colmunIndex == 5) {
      if (uvaRun.getStatus() == UVARunInfoAndFiles.STATUS_JUDGED) {
        return "" + uvaRun.getResult();
      }
      else {
        return "";
      }
    }
    return null;
  }

  public long getNumRunInfo() {
    return listRun.size();
  }

  public UVARunInfoAndFiles getRunInfo(int index) {
    return (UVARunInfoAndFiles)listRun.get(index);
  }

  public void addRunInfo(long userId, long userSiteId, long runId,
                         String sourceId) {
    UVARunInfoAndFiles run = new UVARunInfoAndFiles(userId, userSiteId, runId,
                                                    sourceId);
    listRun.add(run);
    this.fireTableDataChanged();
  }

  public void setProgramReceived(int index, String submitId) {
    UVARunInfoAndFiles runOld = this.getRunInfo(index);
    UVARunInfoAndFiles runNew =
      new UVARunInfoAndFiles(runOld.getUserId(),
                             runOld.getUserSiteId(),
                             runOld.getRunId(),
                             runOld.getSourceId(),
                             submitId);
    listRun.set(index, runNew);
    this.fireTableDataChanged();
  }

  public void setJudged(int index, int result) {
    UVARunInfoAndFiles runOld = this.getRunInfo(index);
    UVARunInfoAndFiles runNew =
      new UVARunInfoAndFiles(runOld.getUserId(),
                             runOld.getUserSiteId(),
                             runOld.getRunId(),
                             runOld.getSourceId(),
                             runOld.getSubmitId(),
                             result);
    listRun.set(index, runNew);
    this.fireTableDataChanged();
  }
}
